#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <error.h>

#define MAXLINELEN 1024

int count(FILE *s, int *sum, int *lines) 
{
  static char buf[MAXLINELEN];
  int x;

  while (! feof(s)) {
   if (fgets(buf, MAXLINELEN, s)== NULL) {
     return errno == 0 ? 0 : -1;
     }
   if (strcmp("STOP\n", buf)== 0) {
     return 0;
     }
   x= atoi(buf);
   *sum += x;
   (*lines)++; 
   }
   return 0;
}

int main(int argc, char *argv[])
{
  char *filenm;
  FILE *s;
  int sum, lines;

  if (argc != 2) {
    fprintf(stderr, "Usage: %s <filenm>\n", argv[0]);
    } else {
    filenm= argv[1];
    if ((s= fopen(filenm, "r"))== NULL) {
      error(0, errno, "when opening %s", filenm);
      } else {
      if (count(s, &sum, &lines) == -1) {
        error(0, errno, "when counting");
        } else {
          printf("%s: sum %d, lines %d\n", filenm, sum, lines);  
        }
        fclose(s);
      }
    }
  return 0;
}