#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <error.h>

#define MAXLINELEN 1024

int count(FILE *s, long long int *sum, int *lines) 
{
  static char buf[MAXLINELEN];
  long long int x;

  while (! feof(s)) {
   if (fgets(buf, MAXLINELEN, s)== NULL) {
     return errno == 0 ? 0 : -1;
     }
   if (strcmp("STOP\n", buf)== 0) {
     return 0;
     }
   x= atoll(buf);
   *sum += x;
   if (index(buf, '\n')- buf == strlen(buf)- 1) { // if buf ends with '\n'
     (*lines)++; 
     }
   }
   return 0;
}

int main(int argc, char *argv[])
{
  char *filenm;
  FILE *s;
  long long int sum;
  int lines;

  if (argc != 2) {
    fprintf(stderr, "Usage: %s <filenm>\n", argv[0]);
    exit(-1);
    }
  filenm= argv[1];
  if ((s= fopen(filenm, "r"))== NULL) {
    error(-1, errno, "error when opening %s", filenm);
    }
  if (count(s, &sum, &lines) == -1) {
    error(-1, errno, "error when counting");
    }
  printf("%s: sum %Ld, lines %d\n", filenm, sum, lines);  
  fclose(s);
  return 0;
}
