module Main where

import Control.Exception
import System.Environment   
import Data.Maybe(mapMaybe)
import Text.Read(readMaybe)

count :: FilePath-> IO ()
count path = (do
  c<- readFile path
  let ls= takeWhile ("STOP" /=) $ lines c
  let s = sum $ mapMaybe readMaybe ls
  putStrLn $ path ++ ": sum " ++ (show s) ++ ", lines "++ show (length ls)
  ) `catch` (\e-> putStrLn (show (e :: IOException)))

main :: IO ()
main = do
  args <- getArgs
  prog <- getProgName
  case args of 
    (arg:_) -> count arg
    _ -> putStrLn $ "Usage: "++ prog ++ " <filenm>"
